searchNodes=[{"ref":"Verbalex.html","title":"Verbalex","type":"module","doc":"Documentation for Verbalex."},{"ref":"Verbalex.html#anything/1","title":"Verbalex.anything/1","type":"function","doc":"Matches any character. Equivalent to &quot;.&quot;"},{"ref":"Verbalex.html#anything_in_classes/1","title":"Verbalex.anything_in_classes/1","type":"function","doc":"Matches any of the characters in a character class. The supported class names are: :alnum - Letters and digits :alpha - Letters :ascii - Character codes 0-127 :blank - Space or tab only :cntrl - Control characters :digit - Decimal digits (same as \\d) :graph - Printing characters, excluding space :lower - Lowercase letters :print - Printing characters, including space :punct - Printing characters, excluding letters, digits, and space :space - Whitespace (the same as \\s from PCRE 8.34) :upper - Uppercase letters :word - &quot;Word&quot; characters (same as \\w) :xdigit - Hexadecimal digits Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.anything_in_classes([:upper, :digit]) |&gt; Vlx.one_or_more() &quot;[[:upper:][:digit:]]+&quot;"},{"ref":"Verbalex.html#anything_in_classes/2","title":"Verbalex.anything_in_classes/2","type":"function","doc":""},{"ref":"Verbalex.html#anything_in_string/1","title":"Verbalex.anything_in_string/1","type":"function","doc":"Matches for any of the characters in the given string. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.anything_in_string(&quot;asdf&quot;) |&gt; Vlx.one_or_more() &quot;[asdf]+&quot;"},{"ref":"Verbalex.html#anything_in_string/2","title":"Verbalex.anything_in_string/2","type":"function","doc":""},{"ref":"Verbalex.html#anything_not_in_classes/1","title":"Verbalex.anything_not_in_classes/1","type":"function","doc":"Matches any character not covered in the given character classes. Supported class names match anything_in_classes functionality. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.anything_not_in_classes([:upper, :digit]) |&gt; Vlx.one_or_more() &quot;[^[:upper:][:digit:]]+&quot;"},{"ref":"Verbalex.html#anything_not_in_classes/2","title":"Verbalex.anything_not_in_classes/2","type":"function","doc":""},{"ref":"Verbalex.html#anything_not_in_string/1","title":"Verbalex.anything_not_in_string/1","type":"function","doc":"Matches for anything but the characters in the given string. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.anything_not_in_string(&quot;asdf&quot;) |&gt; Vlx.one_or_more() &quot;[^asdf]+&quot;"},{"ref":"Verbalex.html#anything_not_in_string/2","title":"Verbalex.anything_not_in_string/2","type":"function","doc":""},{"ref":"Verbalex.html#atomize/1","title":"Verbalex.atomize/1","type":"function","doc":"Wraps a regex string in a non-capturing group. This facilitates easy application of things like quantifiers or backreferences to the entirety of a given expression. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; protocol = Vlx.find(&quot;http&quot;) |&gt; Vlx.maybe(&quot;s&quot;) |&gt; Vlx.then(&quot;://&quot;) |&gt; Vlx.atomize() iex&gt; Vlx.maybe(protocol) |&gt; Vlx.then(&quot;www.&quot;) &quot;(?:(?:http)s?(?:://))?(?:www\\\\.)&quot;"},{"ref":"Verbalex.html#atomize/2","title":"Verbalex.atomize/2","type":"function","doc":""},{"ref":"Verbalex.html#capture/1","title":"Verbalex.capture/1","type":"function","doc":""},{"ref":"Verbalex.html#capture/3","title":"Verbalex.capture/3","type":"function","doc":"Wraps a regex string in a capturing group. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; pattern = Vlx.find(&quot;this&quot;) |&gt; Vlx.then(&quot;that&quot;) iex&gt; Vlx.capture(pattern) &quot;((?:this)(?:that))&quot;"},{"ref":"Verbalex.html#capture_as/2","title":"Verbalex.capture_as/2","type":"function","doc":"Wraps a regex string in a named-capturing group. To be utilised with Regex.named_captures(regex, string, options \\\\ []). Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.find(&quot;http&quot;) |&gt; Vlx.maybe(&quot;s&quot;) |&gt; Vlx.then(&quot;://&quot;) |&gt; Vlx.capture_as(&quot;protocols&quot;) &quot;(?&lt;protocols&gt;(?:http)s?(?::\\/\\/))&quot;"},{"ref":"Verbalex.html#carriage_return/1","title":"Verbalex.carriage_return/1","type":"function","doc":"Matches a carriage return character. Equivalent to &quot;\\r&quot;."},{"ref":"Verbalex.html#digit/1","title":"Verbalex.digit/1","type":"function","doc":"Matches a digit (0-9). Equivalent to &quot;\\d&quot;."},{"ref":"Verbalex.html#end_of_line/1","title":"Verbalex.end_of_line/1","type":"function","doc":"Express the end of a line regex anchor. Translates to &#39;$&#39;. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.find(&quot;far, far, away.&quot;) |&gt; Vlx.end_of_line() |&gt; Regex.compile!() ~r/(?:far,\\ far,\\ away\\.)$/"},{"ref":"Verbalex.html#find/1","title":"Verbalex.find/1","type":"function","doc":""},{"ref":"Verbalex.html#find/3","title":"Verbalex.find/3","type":"function","doc":"Express a string literal to be matched exactly and wraps in a non-capturing group. Alias of then/3 for readability semantics, as &#39;find&#39; is a makes more sense when placed at the beginning of a pipe chain. NOTE: Under the current implementation, when using the escape: false option in pipe chains beginning with find, an empty string must be provided as the first value. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.find(&quot;needle&quot;) |&gt; Vlx.if_preceded_by(&quot;hay&quot;) |&gt; Vlx.if_followed_by(&quot;stack&quot;) &quot;(?&lt;=hay)(?:needle)(?=stack)&quot;"},{"ref":"Verbalex.html#if_followed_by/3","title":"Verbalex.if_followed_by/3","type":"function","doc":"Takes a regex string and applies a lookahead condition. Escapes special characters by default. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.find(&quot;sentence&quot;) |&gt; Vlx.if_followed_by(&quot;.&quot;) |&gt; Vlx.capture() &quot;((?:sentence)(?=\\\\.))&quot;"},{"ref":"Verbalex.html#if_not_followed_by/3","title":"Verbalex.if_not_followed_by/3","type":"function","doc":"Takes a regex string and applies a negative lookahead condition. Escapes special characters by default. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.find(&quot;good&quot;) |&gt; Vlx.if_not_followed_by(&quot;bye&quot;) |&gt; Vlx.capture() &quot;((?:good)(?!bye))&quot;"},{"ref":"Verbalex.html#if_not_preceded_by/3","title":"Verbalex.if_not_preceded_by/3","type":"function","doc":"Takes a regex string and applies a negative lookbehind condition. Escapes special characters by default. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.digit() |&gt; Vlx.if_not_preceded_by(&quot;%&quot;) |&gt; Vlx.capture() &quot;((?&lt;!%)\\d)&quot;"},{"ref":"Verbalex.html#if_preceded_by/3","title":"Verbalex.if_preceded_by/3","type":"function","doc":"Takes a regex string and applies a lookbehind condition. Escapes special characters by default. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.digit() |&gt; Vlx.if_preceded_by(&quot;$&quot;) |&gt; Vlx.capture() &quot;((?&lt;=\\\\$)\\d)&quot;"},{"ref":"Verbalex.html#linebreak/1","title":"Verbalex.linebreak/1","type":"function","doc":"Matches a linebreak character. Equivalent to &quot;\\n&quot;."},{"ref":"Verbalex.html#maybe/3","title":"Verbalex.maybe/3","type":"function","doc":"Express a pattern as being optional to match. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.find(&quot;colo&quot;) |&gt; Vlx.maybe(&quot;u&quot;) |&gt; Vlx.then(&quot;r&quot;) &quot;(?:colo)u?(?:r)&quot;"},{"ref":"Verbalex.html#not_digit/1","title":"Verbalex.not_digit/1","type":"function","doc":"Matches anything but a digit (0-9). Equivalent to &quot;\\D&quot;."},{"ref":"Verbalex.html#not_whitespace/1","title":"Verbalex.not_whitespace/1","type":"function","doc":"Matches anything but whitespace character - includes tabs and line breaks."},{"ref":"Verbalex.html#not_word/1","title":"Verbalex.not_word/1","type":"function","doc":"Matches anything but a &#39;word&#39;, equivalent to [^a-zA-Z0-9_]"},{"ref":"Verbalex.html#occurs/2","title":"Verbalex.occurs/2","type":"function","doc":"Specify the number of expected occurences to be found on a given expression. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.digit() |&gt; Vlx.capture() |&gt; Vlx.occurs(4) &quot;(\\d){4}&quot;"},{"ref":"Verbalex.html#occurs_in_range/3","title":"Verbalex.occurs_in_range/3","type":"function","doc":"Specify the range of expected occurences to be found on a given expression. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.digit() |&gt; Vlx.capture() |&gt; Vlx.occurs_in_range(3, 6) &quot;(\\d){3,6}&quot;"},{"ref":"Verbalex.html#one_or_more/3","title":"Verbalex.one_or_more/3","type":"function","doc":"Express a pattern will occur one or more times. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.anything_in_classes(:alnum) |&gt; Vlx.one_or_more() &quot;[[:alnum:]]+&quot;"},{"ref":"Verbalex.html#or_expressions/3","title":"Verbalex.or_expressions/3","type":"function","doc":"Takes in a list of regex strings, and inserts an or operator between each of them. Does not escape characters by default to preference OR-ing complex expressions and encourage composition. Special character escaping is available via the escape: true option. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; accepted_exprs = [&quot;match&quot;, &quot;any&quot;, &quot;of&quot;, &quot;these&quot;] iex&gt; Vlx.or_expressions(accepted_exprs) &quot;(match|any|of|these)&quot;"},{"ref":"Verbalex.html#start_of_line/1","title":"Verbalex.start_of_line/1","type":"function","doc":"Express the start of a line regex anchor. Translates to &#39;^&#39;. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.start_of_line() |&gt; Vlx.find(&quot;A long time ago...&quot;) |&gt; Regex.compile!() ~r/^(?:A\\ long\\ time\\ ago\\.\\.\\.)/"},{"ref":"Verbalex.html#tab/1","title":"Verbalex.tab/1","type":"function","doc":"Matches a tab character. Equivalent to &quot;\\t&quot;."},{"ref":"Verbalex.html#then/3","title":"Verbalex.then/3","type":"function","doc":"Express a string literal to be matched exactly and wraps in a non-capturing group. Escapes special characters by default. Turn off character escapes with the escape: false option. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.find(&quot;www.&quot;) |&gt; Vlx.then(&quot;example.com&quot;) &quot;(?:www\\\\.)(?:example\\\\.com)&quot;"},{"ref":"Verbalex.html#whitespace/1","title":"Verbalex.whitespace/1","type":"function","doc":"Matches a whitespace character - includes tabs and line breaks."},{"ref":"Verbalex.html#word/1","title":"Verbalex.word/1","type":"function","doc":"Matches a &#39;word&#39;, equivalent to [a-zA-Z0-9_]"},{"ref":"Verbalex.html#word_boundary/1","title":"Verbalex.word_boundary/1","type":"function","doc":"Matches a &#39;word boundary&#39; - a word bounary is the position between a word and non-word character (0-9A-Za-z_]). It is commonly thought of as matching the beginning or end of a string."},{"ref":"Verbalex.html#zero_or_more/3","title":"Verbalex.zero_or_more/3","type":"function","doc":"Express a pattern will occur zero or more times. Examples iex&gt; alias Verbalex, as: Vlx iex&gt; Vlx.anything_in_classes(:alnum) |&gt; Vlx.zero_or_more() &quot;[[:alnum:]]*&quot;"},{"ref":"readme.html","title":"Verbalex","type":"extras","doc":"Verbalex Verbalex is a library for creating complex regular expressions with the reader &amp; writer in mind. It does not aim to replace Elixir&#39;s already excellent Regex module for operating on regex. Instead, it focuses only on building the ~r/regexes/ themselves. alias Verbalex, as: Vlx protocols = &quot;&quot; |&gt; Vlx.find(&quot;http&quot;) |&gt; Vlx.maybe(&quot;s&quot;) |&gt; Vlx.then(&quot;://&quot;) |&gt; Vlx.capture_as(&quot;protocols&quot;) |&gt; Regex.compile!() # ~r/(?&lt;protocols&gt;(?:http)s?(?::\\/\\/))/ Regex.named_captures(protocols, &quot;https://github.com/tylerbarker&quot;) # %{&quot;protocols&quot; =&gt; &quot;https://&quot;}"},{"ref":"readme.html#installation","title":"Verbalex - Installation","type":"extras","doc":"def deps do [ {:verbalex, &quot;~&gt; 0.1.0-dev&quot;} ] end"},{"ref":"readme.html#docs","title":"Verbalex - Docs","type":"extras","doc":"Documentation can be found at https://hexdocs.pm/verbalex."},{"ref":"readme.html#acknowledgements","title":"Verbalex - Acknowledgements","type":"extras","doc":"Verbalex is essentially an Elixir port of the popular Verbal Expressions family of libraries, while also taking some inspiration from Simple Regex. Thanks to Max Szengal for laying down some of the groundwork in 2013 with ElixirVerbalExpressions."},{"ref":"readme.html#contributing","title":"Verbalex - Contributing","type":"extras","doc":"For issues, comments or feedback please first create an issue."}]